#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf nas-1.9.3.src.tar.gz
    cd nas-1.9.3
    xmkmf
    make World CDEBUGFLAGS="$CFLAGS -fno-strict-aliasing"
    strip -R .note -R .comment server/nasd
    mkdir -p ../nasd/sbin
    cp server/nasd ../nasd/sbin/
    cd ..
    rm -rf nas-1.9.3
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
